unit frmmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, TAStyles, TASeries, Forms, Controls,
  Graphics, Dialogs, EditBtn, StdCtrls, readstats;

type

  { TMainForm }

  TMainForm = class(TForm)
    BGo: TButton;
    CChars: TChart;
    CCharsBarSeries1: TBarSeries;
    CBRecurse: TCheckBox;
    DEDir: TDirectoryEdit;
    EExt: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure BGoClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    FStats : TStats;
    procedure ShowStats(ACount : Integer);
  public
    { public declarations }

  end;

var
  MainForm: TMainForm;

implementation

{$R *.lfm}

{ TMainForm }



procedure TMainForm.FormCreate(Sender: TObject);

Var
  B : TBarSeries;
  I : Integer;

begin
  DEDir.Directory:=ExtractFilePath(ParamStr(0));
  B:=CChars.Series[0] as TBarSeries;
  For I:=0 to 255 do
    begin
    B.AddXY(i,0);
    end;
end;

procedure TMainForm.ShowStats(ACount : Integer);

Var
  B : TBarSeries;
  I : Integer;
  C : Int64;

begin
  B:=CChars.Series[0] as TBarSeries;
  C:=FStats[256];
  CChars.Title.Text[1]:=Format('%d files processed',[C]);
  C:=0;
  For I:=0 to 255 do
    C:=C+FStats[I];
  For I:=0 to 255 do
    B.SetYValue(I,FStats[i]/C*100);
end;


procedure TMainForm.BGoClick(Sender: TObject);

Var
  E,D : String;
  I : integer;

begin
  D:=IncludeTrailingPathDelimiter(DEDir.Directory);
  E:=EExt.Text;
  For I:=1 to Length(E) do
    If E[i]=' ' then E[I]:='.';
  E:='.'+E+'.';
  E:=StringReplace(E,'..','.',[rfReplaceAll]);
  FillWord(FStats,SizeOf(FStats) div 2,0);
  i:=GetStats(FStats,D,E,CBRecurse.Checked);
  ShowStats(i);
end;

end.

