unit frmmain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, TAGraph, TAStyles, TASeries, Forms, Controls,
  Graphics, Dialogs, EditBtn, StdCtrls, readstats;

type

  { TMainForm }

  TMainForm = class(TForm)
    BGO: TButton;
    CChars: TChart;
    CCharsBarSeries1: TBarSeries;
    CBRecurse: TCheckBox;
    DEDir: TDirectoryEdit;
    EExt: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure BGOClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    FStats : TStats;
    procedure ShowStats(ACount : Integer);
    procedure ThreadDone(Sender: TObject);
  public
    { public declarations }

  end;

var
  MainForm: TMainForm;

implementation

{$R *.lfm}

{ TMainForm }
Type

  { TStatsThread }

  TStatsThread = Class(TThread)
  private
    FDirectory : String;
    FExtensions : String;
    FRecurse : Boolean;
    FStats : PStats;
  Public
    Constructor Create(AStats : PSTats; ADirectory,AExtensions : String; Recurse : Boolean; AOnDestroy : TNotifyEvent);
    Procedure Execute; override;
  end;

{ TStatsThread }

constructor TStatsThread.Create(AStats: PSTats; ADirectory,
  AExtensions: String; Recurse: Boolean; AOnDestroy: TNotifyEvent);
begin
  FDirectory:=ADirectory;
  FExtensions:=AExtensions;
  FRecurse:=Recurse;
  FStats:=ASTats;
  OnTerminate:=AOndestroy;
  FreeOnTerminate:=True;
  Inherited Create(False);
end;

procedure TStatsThread.Execute;
begin
  GetStats(FStats^,FDirectory,FExtensions,FRecurse);
end;


procedure TMainForm.FormCreate(Sender: TObject);

Var
  B : TBarSeries;
  I : Integer;

begin
  DEDir.Directory:=ExtractFilePath(ParamStr(0));
  B:=CChars.Series[0] as TBarSeries;
  For I:=0 to 255 do
    begin
    B.AddXY(i,0);
    end;
end;

procedure TMainForm.ShowStats(ACount : Integer);

Var
  B : TBarSeries;
  I : Integer;
  C : Int64;

begin
  B:=CChars.Series[0] as TBarSeries;
  C:=FStats[256];
  CChars.Title.Text[1]:=Format('%d files processed',[C]);
  C:=0;
  For I:=0 to 255 do
    C:=C+FStats[I];
  For I:=0 to 255 do
    B.SetYValue(I,FStats[i]/C*100);
end;

procedure TMainForm.ThreadDone(Sender: TObject);

begin
  ShowStats(0);
end;

procedure TMainForm.BGOClick(Sender: TObject);

Var
  E,D : String;
  I : integer;

begin
  D:=IncludeTrailingPathDelimiter(DEDir.Directory);
  E:=EExt.Text;
  For I:=1 to Length(E) do
    If E[i]=' ' then E[I]:='.';
  E:='.'+E+'.';
  E:=StringReplace(E,'..','.',[rfReplaceAll]);
  FillWord(FStats,SizeOf(FStats) div 2,0);
  TStatsThread.Create(@FStats,D,E,CBRecurse.Checked,@ThreadDone);
end;

end.

